# bdm::BM Class Reference

`#include <libBM.h>`

Inheritance diagram for bdm::BM:

[legend]

List of all members.

## Detailed Description

Bayesian Model of a system, i.e. all uncertainty is modeled by probabilities.

## Public Member Functions
Constructors
| BM ()
| BM (const BM &B)
virtual BM * | _copy_ ()
Mathematical operations
virtual void | bayes (const vec &dt)=0
| Incremental Bayes rule.
virtual void | bayesB (const mat &Dt)
| Batch Bayes rule (columns of Dt are observations).
virtual double | logpred (const vec &dt) const
vec | logpred_m (const mat &dt) const
| Matrix version of logpred.
virtual epdf * | epredictor () const
| Constructs a predictive density .
virtual mpdf * | predictor () const
| Constructs a conditional density 1-step ahead predictor.
Access to attributes
const RV & | _drv () const
void | set_drv (const RV &rv)
double | _ll () const
void | set_evalll (bool evl0)
virtual const epdf & | _epdf () const =0
virtual const epdf * | _e () const =0
## Protected Attributes
RV | drv
| Random variable of the data (optional).
double | ll
| Logarithm of marginalized data likelihood.
bool | evalll
| If true, the filter will compute likelihood of the data record and store it in `ll` . Set to false if you want to save computational time.

## Member Function Documentation

virtual BM* bdm::BM::_copy_ | ( |  | ) | `[inline, virtual]`

Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually! Prototype:

     BM* _copy_(){return new BM(*this);}

Reimplemented in bdm::ARX.

virtual void bdm::BM::bayes | ( | const vec & | dt | ) | `[pure virtual]`

Incremental Bayes rule.

Parameters:

  | dt | vector of input data

Implemented in bdm::ARX, bdm::Kalman< sq_T >, bdm::KalmanCh, bdm::EKFfull, bdm::EKF< sq_T >, bdm::EKFCh, bdm::PF, bdm::MPF< BM_T >, bdm::MixEF, bdm::BMEF, bdm::multiBM, bdm::Kalman< ldmat >, bdm::Kalman< chmat >, and bdm::Kalman< fsqmat >.

Referenced by bayesB().

virtual double bdm::BM::logpred | ( | const vec & | dt | ) | const`[inline, virtual]`

Evaluates predictive log-likelihood of the given data record I.e. marginal likelihood of the data with the posterior integrated out.

Reimplemented in bdm::ARX, bdm::MixEF, and bdm::multiBM.

Referenced by logpred_m().

The documentation for this class was generated from the following files:

- libBM.h
- libBM.cpp